/*
 * graph2D
 * Copyright (c) 2009 Shun Moriya <shun126@users.sourceforge.jp>
 *
 * This software is provided 'as-is', without any express or implied
 * warranty. In no event will the authors be held liable for any damages
 * arising from the use of this software.
 *
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, and to alter it and redistribute it
 * freely, subject to the following restrictions:
 *
 *  1. The origin of this software must not be misrepresented; you must not
 *     claim that you wrote the original software. If you use this software
 *     in a product, an acknowledgment in the product documentation would be
 *     appreciated but is not required.
 *
 *  2. Altered source versions must be plainly marked as such, and must not be
 *     misrepresented as being the original software.
 *
 *  3. This notice may not be removed or altered from any source
 *     distribution.
 */

#if !defined(___GRAPH2D_ABORT_H___)
#define ___GRAPH2D_ABORT_H___

namespace Graph2D
{
	typedef enum ERROR_CODE
	{
		ERROR_CODE_INVALID = 0,
		ERROR_CODE_FILE_NOT_FOUND,
		ERROR_CODE_FILE_OPEN_FAILED,
		ERROR_CODE_FILE_READ_FAILED,
		ERROR_CODE_FILE_WRITE_FAILED,
		ERROR_CODE_NOT_ENOUGH_MEMORY,
		ERROR_CODE_ILLEGAL_MEMORY_BLOCK_RELEASED,
		ERROR_CODE_ILLEGAL_SCENE_OBJECT_DETECTED,
		ERROR_CODE_ILLEGAL_MESSAGE_OBJECT_DETECTED,
		ERROR_CODE_SIZE
	}ERROR_CODE;

	void abort(const ERROR_CODE errorCode = ERROR_CODE_INVALID, const char* hint = 0);
}

#endif
