/*
 * graph2D
 * Copyright (c) 2011 Shun Moriya <shun126@users.sourceforge.jp>
 *
 * This software is provided 'as-is', without any express or implied
 * warranty. In no event will the authors be held liable for any damages
 * arising from the use of this software.
 *
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, and to alter it and redistribute it
 * freely, subject to the following restrictions:
 *
 *  1. The origin of this software must not be misrepresented; you must not
 *     claim that you wrote the original software. If you use this software
 *     in a product, an acknowledgment in the product documentation would be
 *     appreciated but is not required.
 *
 *  2. Altered source versions must be plainly marked as such, and must not be
 *     misrepresented as being the original software.
 *
 *  3. This notice may not be removed or altered from any source
 *     distribution.
 */

#include "base.h"

namespace Graph2D
{
#if !defined(TARGET_WINDOWS)
#if defined(NDEBUG)
	void* Base::operator new(size_t size) throw()
	{
		return global_heap.malloc(size);
	}

	void* Base::operator new[](size_t size) throw()
	{
		return global_heap.malloc(size);
	}
#else
	void* Base::operator new(size_t size, const char* comment) throw()
	{
		return global_heap.malloc(size, comment);
	}

	void* Base::operator new[](size_t size, const char* comment) throw()
	{
		return global_heap.malloc(size, comment);
	}
#endif

	void Base::operator delete(void* buffer) throw()
	{
		global_heap.free(buffer);
	}

	void Base::operator delete[](void* buffer) throw()
	{
		global_heap.free(buffer);
	}
#endif
}
