/*
 * graph2D
 * Copyright (c) 2009 Shun Moriya <shun126@users.sourceforge.jp>
 * 
 * This software is provided 'as-is', without any express or implied
 * warranty. In no event will the authors be held liable for any damages
 * arising from the use of this software.
 * 
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, and to alter it and redistribute it
 * freely, subject to the following restrictions:
 * 
 *  1. The origin of this software must not be misrepresented; you must not
 *     claim that you wrote the original software. If you use this software
 *     in a product, an acknowledgment in the product documentation would be
 *     appreciated but is not required.
 * 
 *  2. Altered source versions must be plainly marked as such, and must not be
 *     misrepresented as being the original software.
 * 
 *  3. This notice may not be removed or altered from any source
 *     distribution.
 */

#if !defined(___GRAPH2D_BORDER_LAYOUT_H___)
#define ___GRAPH2D_BORDER_LAYOUT_H___

#include "layout.h"

namespace Graph2D
{
	class Container;

	class BorderLayout : public Layout
	{
		typedef Layout super;

		static const int NORTH = 0;
		static const int SOUTH = 1;
		static const int EAST = 2;
		static const int WEST = 3;
		static const int CENTER = 4;

	public:
		BorderLayout();
		virtual ~BorderLayout();

		void apply(Container* container);
	};
}

#endif
