/*
 * graph2D
 * Copyright (c) 2009 Shun Moriya <shun126@users.sourceforge.jp>
 *
 * This software is provided 'as-is', without any express or implied
 * warranty. In no event will the authors be held liable for any damages
 * arising from the use of this software.
 *
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, and to alter it and redistribute it
 * freely, subject to the following restrictions:
 *
 *  1. The origin of this software must not be misrepresented; you must not
 *     claim that you wrote the original software. If you use this software
 *     in a product, an acknowledgment in the product documentation would be
 *     appreciated but is not required.
 *
 *  2. Altered source versions must be plainly marked as such, and must not be
 *     misrepresented as being the original software.
 *
 *  3. This notice may not be removed or altered from any source
 *     distribution.
 */

#if !defined(___GRAPH2D_TEXTURE_IMPL_H___)
#define ___GRAPH2D_TEXTURE_IMPL_H___

#include "../../graphicDevice.h"
#include "vector2.h"
#include <string>

namespace Graph2D
{
	namespace Implementation
	{
		namespace Texture
		{
			void* load(const std::string& filename, const bool compressed);
			void unload(void* self, const bool compressed);
			GLuint getName(void* self, const bool compressed);
			Vector2 getSize(void* self, const bool compressed);
			Vector2 getTextureSize(void* self, const bool compressed);
			Vector2 getMaxSize(void* self, const bool compressed);
		}
	}
}

#endif

