/*
 * graph2D
 * Copyright (c) 2009 Shun Moriya <shun126@users.sourceforge.jp>
 *
 * This software is provided 'as-is', without any express or implied
 * warranty. In no event will the authors be held liable for any damages
 * arising from the use of this software.
 *
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, and to alter it and redistribute it
 * freely, subject to the following restrictions:
 *
 *  1. The origin of this software must not be misrepresented; you must not
 *     claim that you wrote the original software. If you use this software
 *     in a product, an acknowledgment in the product documentation would be
 *     appreciated but is not required.
 *
 *  2. Altered source versions must be plainly marked as such, and must not be
 *     misrepresented as being the original software.
 *
 *  3. This notice may not be removed or altered from any source
 *     distribution.
 */

#include "abort_impl.h"
#include <windows.h>
#include <cstdlib>

namespace Graph2D
{
	extern const wchar_t* errorMessages[] = {
		L"エラーが発生しました",
		L"ファイルを開けません",
		L"ファイルの書き込みに失敗しました",
		L"メモリが不足しています",
	};

	namespace Windows
	{
		void abort_impl(const wchar_t* message)
		{
			::MessageBox(NULL, message, L"", MB_ICONERROR|MB_OK);
			//::exit(errorCode);
			::abort();
		}
	}
}
